#pragma once

#include "Block.h"
#include "DefaultEventListener.h"

#include <Vec3.h>
#include <Array.h>
#include <Datei.h>
#include <Punkt.h>

class Game;

class Chunk : public virtual Framework::ReferenceCounter
{
private:
    Game *zGame;
    int dimensionId;
    Framework::Punkt location;
    Block **blocks;
    Chunk *zNeighbours[ 4 ];

public:
    Chunk( Framework::Punkt location, Game *zGame, int dimensionId );
    Chunk( Framework::Punkt location, Game *zGame, int dimensionId, Framework::StreamReader *zReader );
    ~Chunk();
    Block *getBlockAt( Framework::Vec3<int> cLocation ) const;
    Block *zBlockAt( Framework::Vec3<int> cLocation ) const;
    void putBlockAt( Framework::Vec3<int> location, Block *block );
    void setNeighbor( Direction dir, Chunk *zChunk );
    void load( Framework::StreamReader *zReader );
    void save( Framework::StreamWriter *zWriter );
    int getDimensionId() const;
    Framework::Punkt getCenter() const;
    Game *zGameObj() const;
};