#include "Player.h"

Player::Player( Framework::Vec3<float> location, int dimensionId )
    : Entity( PlayerEntityType::INSTANCE, location, dimensionId )
{}

void Player::setName( Framework::Text name )
{
    this->name = name;
}

const char *Player::getName() const
{
    return name;
}

PlayerEntityType::PlayerEntityType()
    : EntityType( ID )
{}

void PlayerEntityType::loadSuperEntity( Entity *zEntity, Framework::StreamReader *zReader ) const
{}

void PlayerEntityType::saveSuperEntity( Entity *zEntity, Framework::StreamWriter *zWriter ) const
{}

Entity *PlayerEntityType::createEntity( Framework::Vec3<float> position, int dimensionId, Game *zTarget ) const
{
    return new Player( position, dimensionId );
}